<?php

// Settings
add_theme_support('post-thumbnails');
add_theme_support( 'automatic-feed-links' );
add_image_size( 'slider-thumbnail', 320, 240);
add_image_size( 'boxwrap', 180, 120, true);

// Sidebar
$args = array(
	'name'          => 'Sidebar',
	'id'            => 'sidebar',
	'description'   => '',
     'class'         => 'sidebar',
	'before_widget' => '<li id="%1$s" class="widget %2$s">',
	'after_widget'  => '</li>',
	'before_title'  => '<h5>',
	'after_title'   => '</h5>' );
if (function_exists('register_sidebar'))
	register_sidebar($args);

// Initialize
add_action( 'init', 'admin_init' );
function admin_init() {
    register_nav_menu( 'navigation', __( 'Primary Menu' ) );
}

// Custom Post Types
include('custom-post-types.php');

// Meta Boxes
include('meta-boxes.php');

// Rename Areas

! defined( 'ABSPATH' ) and exit;


add_action( 'init', array ( 'clap_to_News', 'init' ) );
add_action( 'admin_menu', array ( 'clap_to_News', 'admin_menu' ) );

class clap_to_News
{
    public static function init()
    {
        global $wp_post_types;
        $labels = &$wp_post_types['post']->labels;
        $labels->name = 'News';
        $labels->singular_name = 'News';
        $labels->add_new = 'Add News';
        $labels->add_new_item = 'Add News';
        $labels->edit_item = 'Edit News';
        $labels->new_item = 'News';
        $labels->view_item = 'View News';
        $labels->search_items = 'Search News';
        $labels->not_found = 'No news found';
        $labels->not_found_in_trash = 'No news found in trash';
        $labels->name_admin_bar = 'News';
    }

    public static function admin_menu()
    {
        global $menu;
        global $submenu;
        $menu[5][0] = 'News';
        $submenu['edit.php'][5][0] = 'News';
        $submenu['edit.php'][10][0] = 'Add News';
    }
}

// Nofollow Bookmarks

function nofollow_blogroll( $html ) {
    // remove existing rel attributes
    $html = preg_replace( '/\s?rel=".*"/', '', $html );
    // add rel="nofollow" to all links
    $html = str_replace( '<a ', '<a rel="nofollow" ', $html );
    return $html;
}
add_filter( 'wp_list_bookmarks', 'nofollow_blogroll' );

// Theme Options Framework

if ( !function_exists( 'of_get_option' ) ) {
function of_get_option($name, $default = false) {
	
	$optionsframework_settings = get_option('optionsframework');
	
	// Gets the unique option id
	$option_name = $optionsframework_settings['id'];
	
	if ( get_option($option_name) ) {
		$options = get_option($option_name);
	}
		
	if ( isset($options[$name]) ) {
		return $options[$name];
	} else {
		return $default;
	}
}
}

/* Scripts */
wp_deregister_script('jquery');
wp_deregister_style('NextGEN');
wp_register_script('jquery', 'http://code.jquery.com/jquery-1.8.3.min.js', false, '1.8.3');
wp_register_script('jquery-color', 'http://code.jquery.com/color/jquery.color-git.js', false, '1.9.1');
wp_register_script('jquery-masonry', get_template_directory_uri().'/js/jquery.masonry.min.js', false, '2.1.08');
wp_register_script('clapperboard', get_template_directory_uri().'/js/clapperboard.js', false, '1.0');
wp_register_script('bootstrap', get_template_directory_uri().'/js/bootstrap.min.js', false, '1.0');
wp_register_script('plugins', get_template_directory_uri().'/js/plugins.js', false, '1.0');
wp_register_script('fancybox', get_template_directory_uri().'/fancybox/jquery.fancybox.js', false, '2.1.4');
wp_register_script('fancybox-thumb', get_template_directory_uri().'/fancybox/helpers/jquery.fancybox-thumbs.js', false, '2.1.4');
wp_register_style( 'fancy', get_template_directory_uri().'/fancybox/jquery.fancybox.css');
wp_register_style( 'fancy-thumb', get_template_directory_uri().'/fancybox//helpers/jquery.fancybox-thumbs.css');
wp_enqueue_script('jquery');
wp_enqueue_script('jquery-color');
wp_enqueue_script('bootstrap');
wp_enqueue_script('plugins');
wp_enqueue_script('fancybox');
wp_enqueue_script('jquery-masonry');
wp_enqueue_script('fancybox-thumb');
wp_enqueue_script('clapperboard');
wp_enqueue_style( 'fancy' );
wp_enqueue_style( 'fancy-thumb' );


/* Event Excerpt */

add_filter('em_event_output_placeholder','my_em_styles_placeholders',1,3);
function my_em_styles_placeholders($replace, $EM_Event, $result){
	global $wp_query, $wp_rewrite;
	switch( $result ){
		case '#_MYEXCERPT': 
			$replace = $EM_Event->output("#_EVENTEXCERPT");
			$replace = preg_replace('/<img[^>]+./','', $replace);
			if($result == "#_MYEXCERPT"){
				if ( str_word_count($replace) > 25 ) {
					$length = 25;
					$replace = implode(' ',array_slice(explode(' ', $replace),0,$length));
					$replace = $replace . '... ';
				}
			}
		break;
	}
	return $replace;
}

/* Lightbox Filter */

	

    function lightbox_regex($content){
        global $post;
        $content = preg_replace("/(<a(?![^>]*?rel=['\"]lightbox.*)[^>]*?href=['\"][^'\"]+?\.(?:gif|jpg|jpeg|png)\?{0,1}\S{0,}['\"][^\>]*)>/i" , '$1 class="lightbox" rel="gallery['.$post->ID.']">', $content);
        return $content;
    }
     
    add_filter('the_content', 'lightbox_regex');

?>