<!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
    <title><?php wp_title ( '|', true,'right' ); ?></title>
    <meta charset="<?php bloginfo( 'charset' ); ?>" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=0">
    <link rel="profile" href="http://gmpg.org/xfn/11" />
    <link href="<?php bloginfo('template_directory');?>/css/bootstrap.css" rel="stylesheet" media="screen">
    <link href="<?php bloginfo('template_directory');?>/css/bootstrap-responsive.css" rel="stylesheet">
    <link href="<?php bloginfo('template_directory');?>/css/font-awesome.min.css" rel="stylesheet">
    <!--[if IE 7]>
    	<link rel="stylesheet" href="<?php bloginfo('template_directory');?>/css/ie.css">
        <link rel="stylesheet" href="<?php bloginfo('template_directory');?>/css/font-awesome-ie7.min.css">
    <![endif]-->
    <link href='http://fonts.googleapis.com/css?family=Open+Sans:400,300,300italic,400italic,600,600italic,700,700italic,800italic,800|Droid+Sans:400,700' rel='stylesheet' type='text/css'>
    <link rel="stylesheet" type="text/css" media="screen" href="<?php bloginfo( 'stylesheet_url' ); ?>" />
    <link rel="stylesheet" media="screen" href="<?php bloginfo('template_directory');?>/css/superfish.css">
    <link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />
    <?php
        if ( is_singular() && get_option( 'thread_comments' ) )
            wp_enqueue_script( 'comment-reply' );
        wp_head();
        wp_get_archives('type=monthly&format=link');
    ?>
</head>
<body <?php if(is_front_page()){ ?>class="homepage"<?php } ?>>
	<?php if(is_front_page()){ ?>
    <div class="splash">
        <div class="wrap">
            <div class="logo">
                <img src="<?php bloginfo('template_directory');?>/img/clapperboard-white.png" alt="Clapperboard UK"/>
            </div>
            <div class="sub-type" id="intro">
                <p>is an innovative, charitable, non-profit film making organisation.<br/>Led by young people from script to screen.</p>
            </div>
            <div class="process">
                <img src="<?php bloginfo('template_directory');?>/img/process.png"/>
            </div>
        </div>
    </div>
    <?php } ?>
        <div id="content">
        <div class="container-fluid">
            <div class='row-fluid' id="header">
                  <div class='span4 logospace'>
                    <p><img src="<?php bloginfo('template_directory');?>/img/logo.png"/></p>
                  </div>
                  <div class='span8 navspace'>
                  	<?php wp_nav_menu( array( 'sort_column' => 'menu_order', 'menu_class' => 'menu visible-desktop', 'theme_location' => 'navigation','container_class' => 'navigation' ) ); ?>
                </div>
            </div>
            <div class="spacer"></div>
            <?php if ( !is_front_page() ) { ?>
            <div class="row-fluid padding0">
                <div class="span8 breadcrumbs">
                    <div class="">
                    	<a href="<?php bloginfo('siteurl'); ?>"><?php bloginfo('name'); ?></a>
                        <?php $i; if(have_posts()) : ?><?php while(have_posts()) : the_post(); $i++; if($i==1){ ?>
                        <a href="<?php the_permalink(); ?>"><?php the_title(); ?></a>
                        <?php } endwhile; endif; ?>
                    </div>
                </div>
                <div class="span4">
                    <?php get_search_form(); ?>
                </div>
            </div>
            <div class="spacer"></div>
            <?php } ?>