	$(function() {
		
		/* Animation Functions */

		
		jQuery.fn.extend({
			rotateIn: function () {
				var title = $(this).html();
                var opacity;
				if (title !== '') {
                  opacity = 1;
				} else {
                  opacity = 0.5;
				}
				if ($.support.transition) {
				$(this).stop().transition({
                    rotate: '+=360deg',
                    scale: 1.1,
					opacity: opacity
				});
				} else {
				$(this).fadeTo('slow',0.4);
				}
            }
		});
		
		jQuery.fn.extend({
          rotateOut: function () {
            var title = $(this).html();
            var opacity;
            var scale;
				if (title !== '') {
					opacity = 1;
					scale = 1.5;
				} else {
					opacity = 0;
					scale = 2.5;
				}
				if ($.support.transition) {
				$(this).stop().transition({
                  rotate: '+=360deg',
                  scale: 2.5,
				  opacity: opacity
				});
				} else {
				$(this).fadeOut('fast');
				}
          }
		});

		/* Overlay */
		
		jQuery.fn.extend({
			cpbOverlay: function () {
				var mode = $(this).is('object');
				var type = $(this).attr('title');
				var dest = $(this).attr('href');
				var text = $(this).attr('data-text');

				$(this).wrap('<div class="wrap"/>');
				$(this).parents('.wrap').wrap('<div class="media-container"/>');
				var wrapper = $(this).parents('.wrap');


				/* Check if its a video */
				if (mode) {
					$(wrapper).append('<div class="hit"/><div class="shading"/><div class="play"/><div class="pattern"/><div class="aperture"/>');
					$(wrapper).find('.play').css('opacity',0.5);

					$(wrapper).find('div.hit').live({
                      mouseenter: function() {
                        $(wrapper).find('.play').rotateOut();
						$(wrapper).find('.aperture').rotateIn();
						$(wrapper).find('.shading').animate(
								{
									'backgroundColor' : '#474747'
								}, 150, 'easeInOutSine'
						);
                      },
                      mouseleave: function () {
                        $(wrapper).find('.play').rotateIn();
						$(wrapper).find('.aperture').rotateOut();
						$(wrapper).find('.shading').animate(
								{
									'backgroundColor' : '#ea6142'
								}, 150, 'easeInOutSine'
							);
                      }
					});

					$(wrapper).find('div.hit').click(
					function () {
                     $(this).siblings('.shading,.play,.aperture,.pattern,.text').add(this).fadeOut('fast',
                            function() {
								$(this).remove();
							});
						$('.youtube-player').playVideo();
						return false;
					}
				);
				} else {
					
					var w = $(this).width();
                    var aperture;
					if (w > 300) {
                      aperture = '<div class="aperture"/>';	
					} else {
                      aperture = '';
					}
					
					$(wrapper).append('<a class="hit"/><div class="shading"/><div class="pattern"/>'+aperture);
					$(wrapper).find('a.hit').attr('href',dest).attr('title',type);
					(wrapper).find('.overlay img').unwrap();
					if (type !== '' && text == 'enable') {
						$(wrapper).append('<div class="text"/>');
						$(wrapper).find('.text').html(type);
					}
					$(wrapper).find('a.hit').hover(
                      function () {
                        $(wrapper).find('.text').fadeOut();
                        $(wrapper).find('.aperture').rotateIn();
                        $(wrapper).find('.shading').animate(
								{
									'backgroundColor' : '#474747'
								}, 150, 'easeInOutSine'
							);
						},
                      function () {
                          $(wrapper).find('.text').fadeIn();
                          $(wrapper).find('.aperture').rotateOut();
                          $(wrapper).find('.shading').animate(
                            {
                              'backgroundColor' : '#ea6142'
                            }, 150, 'easeInOutSine'
							);
						});
                }
            }
		});

      function overlayFix() {
		  if ($('.media-container .text').length) { 
				$('.media-container .text').each(function(){
					var marginTop = $(this).height()/2;
					var marginLeft = $(this).width()/2;
					$(this).css('margin-top',-marginTop);
					$(this).css('margin-left',-marginLeft);
				});
		  }
		}

	$('.overlay').each(function(){ $(this).cpbOverlay(); });

	/* FitVid */

	$(".container-fluid").fitVids();

		
	/* Hover Trigger */
		if ($.support.transition) {
			$('.navigation li').hover(
              function () {
						$(this).find('.clapperboard').css({ transformOrigin: '0px 5px', 'outline': '1px solid transparent' }).transition({rotate: '-7deg'}, 200, 'ease');
						// $(this).find('.type').animate({'padding-top':'5px','line-height':'29px'}, 100);
					},
              function () {
						$(this).find('.clapperboard').transition({rotate: '0deg'}, 100, 'ease');
						// $(this).find('.type').animate({'padding-top':'0','line-height':'34px'}, 100);
					}
			);
		}
		
		$('a.button, .em-booking-submit, .breadcrumbs a').hover(
          function () {
						$(this).stop().animate({'padding-right':'40px',backgroundPosition:'right'}, 200, 'easeInOutQuad');
					},
          function () {
						$(this).stop().animate({'padding-right':'10px',backgroundPosition:'left'}, 200, 'easeInOutQuad');
					}
			);
			
			$('.menu li').hover(
          function () {
						$(this).stop().animate({backgroundPosition:'right'}, 200, 'easeInOutQuad');
					},
          function () {
						$(this).stop().animate({backgroundPosition:'left'}, 200, 'easeInOutQuad');
					}
			);
		
		$('.sponsor-slider img').hover(
          function() {
				$(this).stop().fadeTo('slow',1);
			},
          function() {
				$(this).stop().fadeTo('slow',0.75);
			}
		);
		
		$('.boxwrap .social a').hover(
          function () {
						$(this).stop().animate({'padding-left':'5px',backgroundColor:'#ea6142'}, 200, 'easeInOutQuad');
					},
          function () {
						$(this).stop().animate({'padding-left':'0',backgroundColor:'#474747'}, 200, 'easeInOutQuad');
					}
			);
		
		/*
		$('.breadcrumbs li a').hover(
        function () {
        var h = $(this).height();
        var w = $(this).width();
        $(this).height(h).width(w).css('overflow','hidden');
        $(this).find('.overlay').css({'display': 'block'}).transition({rotate: '0deg',y: '+=32',opacity:1}, 200, 'ease');
        },
        function () {
        $(this).find('.overlay').transition({rotate: '0',y: '-=32',opacity:1}, 200, 'ease');
        }
		);
		*/

		$('.search input[type=text]').focus(function() {           
          if($(this).val() == "Search...") 
            $(this).val('');
			}).focusout(function() {
          if($(this).val() === '')
            $(this).val('Search...');
		});

		/* Showreel */

		function showreelFix() {
			$('.showreel .span4').each(function() {$(this).removeAttr('style');});
			if ($(window).width() < 750) {
				$('.showreel .span4:nth-child(2n+1)').css('margin-left',0);
			} else {
				$('.showreel .span4:nth-child(3n+1)').css('margin-left',0);
			}
		}

		showreelFix();

		
		/* Responsive Navigation */
		
		var menuContent = $('ul.menu').html();
		var highestCol = Math.max($('.logospace').height(),$('.navspace').height());
		$('.navspace').height(highestCol).css('line-height',highestCol+'px');
		$('ul.menu').superfish({
			'animation': {opacity:'show',height:'show'},
			'cssArrows': false,
			'delay': 500
			});
		$('ul.menu li a').not("ul.menu li ul a").wrapInner('<span class="type"/>');
		if (!$.browser.msie) {
		$('ul.menu li a').not('ul.menu li ul a').append('<span class="clapperboard"/>');
		$('div.navigation').prepend('<i class="icon-list menu-toggle"/><div class="clearfix"/>');
		$('#header').after('<div class="row-fluid" id="mobilenav"/>');
		$('#mobilenav').append('<ul class="menu-mobile"/>');
		$('div.navigation').find('.menu-toggle').wrap('<div id="menu-toggle" class="hidden-desktop"/>');
		$('.menu-mobile').html(menuContent);
		$('#menu-toggle').click(function() {
			$(this).toggleClass('mobactive');
			$('#mobilenav').toggle();
			$('.menu-mobile').slideToggle();
		});
		}

		/* Sliders */

		$('div.full-slider ul').bxSlider({
          minSlides: 2,
          maxSlides: 3,
          slideWidth: 320,
          slideMargin: 10,
          moveSlides: 1,
          easing: 'easeInOutQuad',
          speed: 750,
          infiniteLoop: false,
          pager: false,
          auto: true,
          pause: 7000,
          nextText: '',
          prevText: ''
		});

		$('div.sponsor-slider ul').bxSlider({
          minSlides: 3,
          maxSlides: 4,
          slideWidth: 161,
          slideMargin: 10,
          moveSlides: 4,
          easing: 'easeInOutQuad',
          speed: 750,
          pager: false,
          controls: false,
          nextText: '',
          prevText: '',
          auto: true,
          pause: 7000,
          autoStart: true,
          autoHover: true
		});

		/* Pop Out */

		if (!$.browser.msie  && parseInt($.browser.version, 10) !== 7) { 
		$('.popper div').each(function(){
			$(this).hover(function(){
				$(this).stop().animate({
				'padding-left':'15px',
				'padding-right':'0',
				'border-width':'5px'
				}, 500, 'easeInOutBack');
			},function(){
				$(this).stop().animate({
				'border-width':'0',
				'padding-left':'0',
				'padding-right':'15px'
				}, 500, 'easeInOutBack');
			});
		});
		}
		
		/* Fix Events Display */
		
		$('a[href$="http://wp-events-plugin.com"],strong:contains("Category(ies)")').parent().remove();
		$('.em-location-map').parent().css({'padding':'5px','background':'#e7e7e8'});
		$('.em-booking').insertAfter('h5:contains("Bookings")');
		if ($('br').attr('style') == 'clear:both') {
		$(this).remove().nextUntil('.em-booking').wrap('<div class="pull-right"/>');
		}

		/* Competition Countdown */

		$('#counter').countdown({
				timestamp	: (new Date()).getTime() + 20*24*60*60*1000
		});
		
		/* Lightbox */
		
		// $(".row-fluid").find("a:has(img)").attr('rel','grouped');
		
		$(".lightbox").fancybox({
		prevEffect	: 'elastic',
		nextEffect	: 'elastic',
		helpers	: {
			title	: {
				type: 'outside'
			},
			thumbs	: {
				width	: 50,
				height	: 50
			}
		}
	});
	
	// Events hover
	
	

	
	});

	$(window).load(function(){
		
		function splash() {
		if ($('.splash').length) { 
			var browserh = $(window).height();
			var browserw = $(window).width();
			var splashh = $('.splash').height();
			var margint;

			if (browserh > splashh) {
				if ($.browser.msie  && parseInt($.browser.version, 10) === 7) {
				margint = splashh - 24;
				} else {
				margint = splashh + 6;
				}
				splashhh = browserh - 12;
			} else {
				margint = browserh - 6;

			}

			$('#content').css('margin-top',margint);
		}
	}
	splash();
		
		// Fix Type Position
		
		$('.media-container .text').each(function(){
			var marginTop = $(this).height()/2;
			var marginLeft = $(this).width()/2;
			$(this).css('margin-top',-marginTop);
			$(this).css('margin-left',-marginLeft);
		
		// Fade Items In

		$('.showreel .media-container, .full-slider .media-container').each(function(i) {
		$(this).delay((i++) * 100).fadeTo(1000, 1); });
		});
		
		var $container = $('.sponsors');
		
		$container.masonry({
		itemSelector : 'div'
		// isFitWidth: true
		});
		
		$('.sponsors div, .past div.boxwrap').hover(
			function(){
				$(this).stop().fadeTo('slow',1).siblings().stop().fadeTo('slow',0.5);
				},
			function(){
				$(this).stop().fadeTo('fast',0.6).siblings().stop().fadeTo('fast',0.6);
				}
		);
	
	

	$(window).resize(function() {
		splash();
		overlayFix();
		showreelFix();
		var highestCol = Math.max($('.logospace').height(),$('.navspace').height());
		if ($('.logospace').height() > $('.navspace').height())
		$('.navspace').height(highestCol).css('line-height',highestCol+'px');
	});
	
	
});